#!/usr/bin/perl
#                 2006 Y.Senta
######################################
$eqn2gifpath="/mnt/hda3/bin/bin/eqn2gif";
$datapath="data/";
#######################################

@QUERYARRAY;

sub GetQuery {
    local $a;
    local $title;
    local $data;
    local $buffer;

    @QUERYARRAY=();

    if ($ENV{'REQUEST_METHOD'} eq "POST") {
	if ($ENV{'CONTENT_LENGTH'} > 51200) { 
	    #error
	} else {
	    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}
    } else { 
	$buffer = $ENV{'QUERY_STRING'}; 
    }

    foreach $a (split (/&/, $buffer)) {
	($title, $data) = split(/=/, $a, 2);
	$data =~ tr/+/ /;
	$data =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	push(@QUERYARRAY, $title);
	push(@QUERYARRAY, $data);
    }
}

sub SearchQuery {
    local $i;
    for ($i = 0; $i < $#QUERYARRAY; $i += 2){
	if ($QUERYARRAY[$i] eq $_[0]){
	    return $QUERYARRAY[$i+1];
	}
    }
    return "";
}

###############################
GetQuery();
$lasteqn = SearchQuery("eqn");
$mag     = SearchQuery("mag");
$color   = SearchQuery("clr");
$oldid   = SearchQuery("idn");

if ($mag eq ""){
    $mag = "3";
}

if ($color eq ""){
    $color = "white";
}

if ($lasteqn ne ""){
    $cmd = $eqn2gifpath." '".$lasteqn."' ".$datapath.$oldid.".jpg ".$mag." ".$color." >& ".$datapath.$oldid.".log";
    system($cmd);
}

printf ("Content-type: text/html\n\n");
printf ("<html>\n<head>\n");
printf ("<title>eqnfig</title>\n");
printf ("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=shift-jis\">");
printf ("</head><body>\n");
printf ("<H2>EqnFig</H2><HR>");

$newid = $$;

printf "<FORM  ACTION=\"eqnfig.cgi\" METHOD=\"get\">";
printf "<br>";
printf ("<TEXTAREA NAME=\"eqn\" ROWS=6 COLS=60>%s</TEXTAREA><br>\n", $lasteqn);
printf ("<INPUT NAME=\"idn\" VALUE = \"%s\" TYPE = \"hidden\">\n", $newid);
printf "{ (1`10)<br>";
printf ("<INPUT NAME=\"mag\" VALUE = \"%d\" SIZE=10><br>", $mag);
printf "wiF (#RRGGBB)<br>";
printf ("<INPUT NAME=\"clr\" VALUE = \"%s\" SIZE=40>", $color);
printf "<INPUT TYPE=\"submit\" VALUE=\"ϊ\">";
printf "</FORM>";

if ($lasteqn ne ""){
    if (-e $datapath.$oldid.".jpg"){
	printf "<center>";
	printf ("<IMG SRC=\"%s\">", $datapath.$oldid.".jpg");
	printf "</center>";
    }
    if (-s $datapath.$oldid.".log"){
	printf "<center><table border><tr><td>Log</td></tr><tr><td><pre>";
	open(fp, "< " . $datapath.$oldid.".log");
	while (<fp>){
	    printf $_ ;
	}
	close(fp);
	printf "</pre></td></tr></table></center>";
    }
}

printf ("<HR><A HREF=\"../index.html\">Back</A>");

printf ("</BODY></HTML>\n");
